// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb4.lib;
import java.io.*;
import java.net.*;
import krb4.lib.crypto.des;

public class Krb4ADMRep {
String uLose = "KYOULOSE";
String version = "KADM0.0A";

public String returnData;
public int returnCode;
public Krb4ADMRep(byte[] encData, Krb4Creds creds, TCPClient client) throws Krb4Exception,IOException{
    // see if it is plain text (KYOULOSE); 
    if(new String(encData).startsWith(uLose)){
	returnData = uLose;
	Krb4Encode rCode = new Krb4Encode(encData, uLose.length());
	rCode.setByteOrder(false);
	returnCode = rCode.getInt();
	return; 
    }
    // decrypt the response;
    InetAddress address = InetAddress.getLocalHost();
    Krb4KRBPriv krb_priv = new Krb4KRBPriv(encData);
    byte[] unencData = krb_priv.decrypt(creds.sessionKey,
					client.getInetAddress().getAddress(),
					client.getPort(),
					address.getAddress(),
					client.getLocalPort()
					);
    String temp = new String(unencData);
    if(! temp.startsWith(version)){
	System.out.println("Bad Version:"+temp);
	throw new Krb4Exception(Krb4.RD_AP_VERSION);
    }

    Krb4Encode rCode = new Krb4Encode(unencData, version.length());
    rCode.setByteOrder(false);
    returnCode = rCode.getInt();
    if(unencData.length > version.length() + 4){
	Krb4Encode rData = new Krb4Encode(unencData, version.length()+4);
	returnData = rData.getString();
    }

    return;
}

public String getClearData() throws Krb4Exception {
return returnData;
}
}
