// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib;

/**
 * Service Name
 */
public class ServiceName extends PrincipalName {

	/**
	 * Class constructor
	 *
	 * @param name is of type String
	 * @exception RealmException an exception
	 * @see java.lang.String
	 * @see krb5.lib.RealmException
	 */
	public ServiceName(String name) throws RealmException {
		super(name, Krb5.KRB_NT_UNKNOWN);
	}

	/**
	 * Class constructor
	 *
	 * @param name is of type String
	 * @param realm is of type String
	 * @exception RealmException an exception
	 * @see java.lang.String
	 * @see krb5.lib.RealmException
	 */
	public ServiceName(String name, String realm) throws RealmException {
		super(name, Krb5.KRB_NT_UNKNOWN);
		setRealm(realm);
	}

}

