// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib.crypto;

import krb5.lib.*;

public class DesCbcMd4EType extends DesCbcEType {

	public DesCbcMd4EType() {
	}

	public int eType() {
		return Krb5.ETYPE_DES_CBC_MD4;
	}

	public int minimumPadSize() {
		return 0;
	}

	public int confounderSize() {
		return 8;
	}

	public int checksumType() {
		return Krb5.CKSUMTYPE_RSA_MD4;
	}

	public int checksumSize() {
		return 16;
	}

	public byte[] calculateChecksum(byte[] data, int size) {
		md4 mdc = new md4(data, size);
		mdc.calc();
		return mdc.toBytes();
	}

}

