// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib.crypto;

import krb5.lib.*;

public class DesMacKCksumType extends CksumType {

	public DesMacKCksumType() {
	}

	public int confounderSize() {
		return 0;
	}

	public int cksumType() {
		return Krb5.CKSUMTYPE_DES_MAC_K;
	}

	public boolean isSafe() {
		return true;
	}

	public int cksumSize() {
		return 16;
	}

	public int keyType() {
		return Krb5.KEYTYPE_DES;
	}

	public int keySize() {
		return 8;
	}

	public byte[] calculateChecksum(byte[] data, int size) {
		return null;
	}

	public byte[] calculateKeyedChecksum(byte[] data, int size, byte[] key) {
		//calculate des-cbc residue
		long[] key_sched = new long[16];
		//XXX need to check for weak keys
		des.des_set_key(key, key_sched);
		//set ivec to key
		byte[] ivec = new byte[key.length];
		System.arraycopy(key, 0, ivec, 0, key.length);
		byte[] cksum = des.long2octet(des.cbc_cksum(data,
			key_sched, ivec));

		//return value
		return cksum;
	}

	public boolean verifyKeyedChecksum(byte[] data, int size,
		byte[] key, byte[] checksum) {
		byte[] new_cksum = calculateKeyedChecksum(data, data.length, key);
		return isChecksumEqual(checksum, new_cksum);
	}

}
